pcl::TrajkovicKeypoint3D< PointInT, PointOutT, NormalT > Class Template Reference
Module keypoints

TrajkovicKeypoint3D implements Trajkovic and Hedley corner detector on point cloud using geometric information. More...

`#include <pcl/keypoints/trajkovic_3d.h>`

Inheritance diagram for pcl::TrajkovicKeypoint3D< PointInT, PointOutT, NormalT >:

## Public Types

enum | ComputationMethod { FOUR_CORNERS , EIGHT_CORNERS }
using | Ptr = shared_ptr< TrajkovicKeypoint3D< PointInT, PointOutT, NormalT > >
using | ConstPtr = shared_ptr< const TrajkovicKeypoint3D< PointInT, PointOutT, NormalT > >
using | PointCloudIn = typename Keypoint< PointInT, PointOutT >::PointCloudIn
using | PointCloudOut = typename Keypoint< PointInT, PointOutT >::PointCloudOut
using | PointCloudInConstPtr = typename PointCloudIn::ConstPtr
using | Normals = pcl::PointCloud< NormalT >
using | NormalsPtr = typename Normals::Ptr
using | NormalsConstPtr = typename Normals::ConstPtr
Public Types inherited from pcl::Keypoint< PointInT, PointOutT >
using | Ptr = shared_ptr< Keypoint< PointInT, PointOutT > >
using | ConstPtr = shared_ptr< const Keypoint< PointInT, PointOutT > >
using | BaseClass = PCLBase< PointInT >
using | KdTree = pcl::search::Search< PointInT >
using | KdTreePtr = typename KdTree::Ptr
using | PointCloudIn = pcl::PointCloud< PointInT >
using | PointCloudInPtr = typename PointCloudIn::Ptr
using | PointCloudInConstPtr = typename PointCloudIn::ConstPtr
using | PointCloudOut = pcl::PointCloud< PointOutT >
using | SearchMethod = std::function< int(pcl::index_t, double, pcl::Indices &, std::vector< float > &)>
using | SearchMethodSurface = std::function< int(const PointCloudIn &cloud, pcl::index_t index, double, pcl::Indices &, std::vector< float > &)>
Public Types inherited from pcl::PCLBase< PointInT >
using | PointCloud = pcl::PointCloud< PointInT >
using | PointCloudPtr = typename PointCloud::Ptr
using | PointCloudConstPtr = typename PointCloud::ConstPtr
using | PointIndicesPtr = PointIndices::Ptr
using | PointIndicesConstPtr = PointIndices::ConstPtr

## Public Member Functions

| TrajkovicKeypoint3D (ComputationMethod method=FOUR_CORNERS, int window_size=3, float first_threshold=0.00046, float second_threshold=0.03589)
| Constructor. More...
void | setMethod (ComputationMethod method)
| set the method of the response to be calculated. More...
ComputationMethod | getMethod () const
void | setWindowSize (int window_size)
| Set window size. More...
int | getWindowSize () const
void | setFirstThreshold (float threshold)
| set the first_threshold to reject corners in the simple cornerness computation stage. More...
float | getFirstThreshold () const
void | setSecondThreshold (float threshold)
| set the second threshold to reject corners in the final cornerness computation stage. More...
float | getSecondThreshold () const
void | setNormals (const NormalsConstPtr &normals)
| Set normals if precalculated normals are available. More...
void | getNormals () const
void | setNumberOfThreads (unsigned int nr_threads=0)
| Initialize the scheduler and set the number of threads to use. More...
unsigned int | getNumberOfThreads () const
Public Member Functions inherited from pcl::Keypoint< PointInT, PointOutT >
| Keypoint ()
| Keypoint ()
| Empty constructor. More...
void | harrisCorner (PointInT &output, PointInT &input, const float sigma_d, const float sigma_i, const float alpha, const float thresh)
void | hessianBlob (PointInT &output, PointInT &input, const float sigma, bool SCALE)
void | hessianBlob (PointInT &output, PointInT &input, const float start_scale, const float scaling_factor, const int num_scales)
void | imageElementMultiply (PointInT &output, PointInT &input1, PointInT &input2)
| ~Keypoint ()
| Empty destructor. More...
virtual void | setSearchSurface (const PointCloudInConstPtr &cloud)
| Provide a pointer to the input dataset that we need to estimate features at every point for. More...
PointCloudInConstPtr | getSearchSurface ()
| Get a pointer to the surface point cloud dataset. More...
void | setSearchMethod (const KdTreePtr &tree)
| Provide a pointer to the search object. More...
KdTreePtr | getSearchMethod ()
| Get a pointer to the search method used. More...
double | getSearchParameter ()
| Get the internal search parameter. More...
void | setKSearch (int k)
| Set the number of k nearest neighbors to use for the feature estimation. More...
int | getKSearch ()
| get the number of k nearest neighbors used for the feature estimation. More...
void | setRadiusSearch (double radius)
| Set the sphere radius that is to be used for determining the nearest neighbors used for the key point detection. More...
double | getRadiusSearch ()
| Get the sphere radius used for determining the neighbors. More...
pcl::PointIndicesConstPtr | getKeypointsIndices ()
void | compute (PointCloudOut &output)
| Base method for key point detection for all points given in <setInputCloud (), setIndices ()> using the surface in setSearchSurface () and the spatial locator in setSearchMethod () More...
int | searchForNeighbors (pcl::index_t index, double parameter, pcl::Indices &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface. More...
Public Member Functions inherited from pcl::PCLBase< PointInT >
| PCLBase ()
| Empty constructor. More...
| PCLBase (const PCLBase &base)
| Copy constructor. More...
virtual | ~PCLBase ()=default
| Destructor. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (std::size_t row_start, std::size_t col_start, std::size_t nb_rows, std::size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud. More...
IndicesPtr | getIndices ()
| Get a pointer to the vector of indices used. More...
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used. More...
const PointInT & | operator[] (std::size_t pos) const
| Override PointCloud operator[] to shorten code. More...

## Protected Member Functions

bool | initCompute () override
void | detectKeypoints (PointCloudOut &output) override
Protected Member Functions inherited from pcl::Keypoint< PointInT, PointOutT >
const std::string & | getClassName () const
| Get a string representation of the name of this class. More...
virtual void | detectKeypoints (PointCloudOut &output)=0
| Abstract key point detection method. More...
Protected Member Functions inherited from pcl::PCLBase< PointInT >
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...

## Additional Inherited Members

Protected Attributes inherited from pcl::Keypoint< PointInT, PointOutT >
std::string | name_
| The key point detection method's name. More...
SearchMethod | search_method_
| The search method template for indices. More...
SearchMethodSurface | search_method_surface_
| The search method template for points. More...
PointCloudInConstPtr | surface_
| An input point cloud describing the surface that is to be used for nearest neighbors estimation. More...
KdTreePtr | tree_
| A pointer to the spatial search object. More...
double | search_parameter_
| The actual search parameter (casted from either search_radius_ or k_). More...
double | search_radius_
| The nearest neighbors search radius for each point. More...
int | k_
| The number of K nearest neighbors to use for each point. More...
pcl::PointIndicesPtr | keypoints_indices_
| Indices of the keypoints in the input cloud. More...
Protected Attributes inherited from pcl::PCLBase< PointInT >
PointCloudConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...

## Detailed Description

### template<typename PointInT, typename PointOutT, typename NormalT = pcl::Normal>
class pcl::TrajkovicKeypoint3D< PointInT, PointOutT, NormalT >

TrajkovicKeypoint3D implements Trajkovic and Hedley corner detector on point cloud using geometric information.

It uses first order statistics to find variation of normals. This work is part of Nizar Sallem PhD thesis.

Author
  Nizar Sallem

Definition at line 54 of file trajkovic_3d.h.

## Member Typedef Documentation

## ConstPtr

template<typename PointInT , typename PointOutT , typename NormalT = pcl::Normal>

using pcl::TrajkovicKeypoint3D< PointInT, PointOutT, NormalT >::ConstPtr = shared_ptr<const TrajkovicKeypoint3D<PointInT, PointOutT, NormalT> >

Definition at line 58 of file trajkovic_3d.h.

## Normals

template<typename PointInT , typename PointOutT , typename NormalT = pcl::Normal>

using pcl::TrajkovicKeypoint3D< PointInT, PointOutT, NormalT >::Normals = pcl::PointCloud<NormalT>

Definition at line 62 of file trajkovic_3d.h.

## NormalsConstPtr

template<typename PointInT , typename PointOutT , typename NormalT = pcl::Normal>

using pcl::TrajkovicKeypoint3D< PointInT, PointOutT, NormalT >::NormalsConstPtr = typename Normals::ConstPtr

Definition at line 64 of file trajkovic_3d.h.

## NormalsPtr

template<typename PointInT , typename PointOutT , typename NormalT = pcl::Normal>

using pcl::TrajkovicKeypoint3D< PointInT, PointOutT, NormalT >::NormalsPtr = typename Normals::Ptr

Definition at line 63 of file trajkovic_3d.h.

## PointCloudIn

template<typename PointInT , typename PointOutT , typename NormalT = pcl::Normal>

using pcl::TrajkovicKeypoint3D< PointInT, PointOutT, NormalT >::PointCloudIn = typename Keypoint<PointInT, PointOutT>::PointCloudIn

Definition at line 59 of file trajkovic_3d.h.

## PointCloudInConstPtr

template<typename PointInT , typename PointOutT , typename NormalT = pcl::Normal>

using pcl::TrajkovicKeypoint3D< PointInT, PointOutT, NormalT >::PointCloudInConstPtr = typename PointCloudIn::ConstPtr

Definition at line 61 of file trajkovic_3d.h.

## PointCloudOut

template<typename PointInT , typename PointOutT , typename NormalT = pcl::Normal>

using pcl::TrajkovicKeypoint3D< PointInT, PointOutT, NormalT >::PointCloudOut = typename Keypoint<PointInT, PointOutT>::PointCloudOut

Definition at line 60 of file trajkovic_3d.h.

## Ptr

template<typename PointInT , typename PointOutT , typename NormalT = pcl::Normal>

using pcl::TrajkovicKeypoint3D< PointInT, PointOutT, NormalT >::Ptr = shared_ptr<TrajkovicKeypoint3D<PointInT, PointOutT, NormalT> >

Definition at line 57 of file trajkovic_3d.h.

## Member Enumeration Documentation

## ComputationMethod

template<typename PointInT , typename PointOutT , typename NormalT = pcl::Normal>

enum pcl::TrajkovicKeypoint3D::ComputationMethod

Enumerator
FOUR_CORNERS |
EIGHT_CORNERS |

Definition at line 72 of file trajkovic_3d.h.

## Constructor & Destructor Documentation

## TrajkovicKeypoint3D()

template<typename PointInT , typename PointOutT , typename NormalT = pcl::Normal>

pcl::TrajkovicKeypoint3D< PointInT, PointOutT, NormalT >::TrajkovicKeypoint3D | ( | ComputationMethod | method = `FOUR_CORNERS`,
|  | int | window_size = `3`,
|  | float | first_threshold = `0.00046`,
|  | float | second_threshold = `0.03589`
| ) |  |

inline

Constructor.

Parameters

  [in] | method | the method to be used to determine the corner responses
  [in] | window_size |
  [in] | first_threshold | the threshold used in the simple cornerness test.
  [in] | second_threshold | the threshold used to reject weak corners.

Definition at line 80 of file trajkovic_3d.h.

References pcl::Keypoint< PointInT, PointOutT >::name_.

## Member Function Documentation

## detectKeypoints()

template<typename PointInT , typename PointOutT , typename NormalT >

void pcl::TrajkovicKeypoint3D< PointInT, PointOutT, NormalT >::detectKeypoints | ( | PointCloudOut & | output | ) |

override protected

Definition at line 98 of file trajkovic_3d.hpp.

References pcl::B, and pcl::isFinite().

## getFirstThreshold()

template<typename PointInT , typename PointOutT , typename NormalT = pcl::Normal>

float pcl::TrajkovicKeypoint3D< PointInT, PointOutT, NormalT >::getFirstThreshold | ( |  | ) | const

inline

Returns
  first threshold

Definition at line 120 of file trajkovic_3d.h.

## getMethod()

template<typename PointInT , typename PointOutT , typename NormalT = pcl::Normal>

ComputationMethod pcl::TrajkovicKeypoint3D< PointInT, PointOutT, NormalT >::getMethod | ( |  | ) | const

inline

Returns
  the computation method

Definition at line 101 of file trajkovic_3d.h.

## getNormals()

template<typename PointInT , typename PointOutT , typename NormalT = pcl::Normal>

void pcl::TrajkovicKeypoint3D< PointInT, PointOutT, NormalT >::getNormals | ( |  | ) | const

inline

Returns
  points normals as calculated or given

Definition at line 141 of file trajkovic_3d.h.

## getNumberOfThreads()

template<typename PointInT , typename PointOutT , typename NormalT = pcl::Normal>

unsigned int pcl::TrajkovicKeypoint3D< PointInT, PointOutT, NormalT >::getNumberOfThreads | ( |  | ) | const

inline

Returns
  the number of threads

Definition at line 151 of file trajkovic_3d.h.

## getSecondThreshold()

template<typename PointInT , typename PointOutT , typename NormalT = pcl::Normal>

float pcl::TrajkovicKeypoint3D< PointInT, PointOutT, NormalT >::getSecondThreshold | ( |  | ) | const

inline

Returns
  second threshold

Definition at line 131 of file trajkovic_3d.h.

## getWindowSize()

template<typename PointInT , typename PointOutT , typename NormalT = pcl::Normal>

int pcl::TrajkovicKeypoint3D< PointInT, PointOutT, NormalT >::getWindowSize | ( |  | ) | const

inline

Returns
  window size i.e. window width or height

Definition at line 109 of file trajkovic_3d.h.

## initCompute()

template<typename PointInT , typename PointOutT , typename NormalT >

bool pcl::TrajkovicKeypoint3D< PointInT, PointOutT, NormalT >::initCompute

override protected virtual

Reimplemented from pcl::Keypoint< PointInT, PointOutT >.

Definition at line 48 of file trajkovic_3d.hpp.

References pcl::Feature< PointInT, PointOutT >::compute(), pcl::IntegralImageNormalEstimation< PointInT, PointOutT >::setInputCloud(), pcl::IntegralImageNormalEstimation< PointInT, PointOutT >::setNormalEstimationMethod(), and pcl::IntegralImageNormalEstimation< PointInT, PointOutT >::setNormalSmoothingSize().

## setFirstThreshold()

template<typename PointInT , typename PointOutT , typename NormalT = pcl::Normal>

void pcl::TrajkovicKeypoint3D< PointInT, PointOutT, NormalT >::setFirstThreshold | ( | float | threshold | ) |

inline

set the first_threshold to reject corners in the simple cornerness computation stage.

Parameters

  [in] | threshold |

Definition at line 116 of file trajkovic_3d.h.

## setMethod()

template<typename PointInT , typename PointOutT , typename NormalT = pcl::Normal>

void pcl::TrajkovicKeypoint3D< PointInT, PointOutT, NormalT >::setMethod | ( | ComputationMethod | method | ) |

inline

set the method of the response to be calculated.

Parameters

  [in] | method | either 4 corners or 8 corners

Definition at line 97 of file trajkovic_3d.h.

## setNormals()

template<typename PointInT , typename PointOutT , typename NormalT = pcl::Normal>

void pcl::TrajkovicKeypoint3D< PointInT, PointOutT, NormalT >::setNormals | ( | const NormalsConstPtr & | normals | ) |

inline

Set normals if precalculated normals are available.

Parameters

  normals |

Definition at line 137 of file trajkovic_3d.h.

## setNumberOfThreads()

template<typename PointInT , typename PointOutT , typename NormalT = pcl::Normal>

void pcl::TrajkovicKeypoint3D< PointInT, PointOutT, NormalT >::setNumberOfThreads | ( | unsigned int | nr_threads = `0` | ) |

inline

Initialize the scheduler and set the number of threads to use.

Parameters

  nr_threads | the number of hardware threads to use, 0 for automatic.

Definition at line 147 of file trajkovic_3d.h.

## setSecondThreshold()

template<typename PointInT , typename PointOutT , typename NormalT = pcl::Normal>

void pcl::TrajkovicKeypoint3D< PointInT, PointOutT, NormalT >::setSecondThreshold | ( | float | threshold | ) |

inline

set the second threshold to reject corners in the final cornerness computation stage.

Parameters

  [in] | threshold |

Definition at line 127 of file trajkovic_3d.h.

## setWindowSize()

template<typename PointInT , typename PointOutT , typename NormalT = pcl::Normal>

void pcl::TrajkovicKeypoint3D< PointInT, PointOutT, NormalT >::setWindowSize | ( | int | window_size | ) |

inline

Set window size.

Definition at line 105 of file trajkovic_3d.h.

The documentation for this class was generated from the following files:

- pcl/keypoints/trajkovic_3d.h
- pcl/keypoints/impl/trajkovic_3d.hpp